/*
   Save the current alarmlist from TView to a file. This can be imported
   back into TView with help of Alarmlist_Load.rexx

   Version 1.0  10/nov/2003
   Dagfinn Olsen (dagfolse@online.no)

   Important! There is no "hotkey" in NList to toggle "select all",
   "deselect all", so I had to make some limits. You have to select
   all the lines in the alarmlist window you want to save. Then you
   run this script from menu.

   Script will not work, if you try to run it again, with same selected
   items. If you want to rerun it, first deselect all, and reselect those
   you want saved from the alarmlist window. Otherwise it will fail.

  ==========================================================================
  = Script uses several "wait", so it will take a few seconds to complete  =
  = the script. Please *do not* use mouse/keyboard while script is runing! =
  = When it's finished, a request should pop up notifying list is saved.   =
  ==========================================================================

   This script asumes all is correct installed. There are no error-checking
   at all, so make sure all is properly installed and runing.

   Requires following files:
   =========================
   RexxEvent1_21.lha                            installed and runing as commodity
   RexxTricks_386.lha                           rexxtricks.library in Libs:
   SetWin              from SetWin1.0.lha       script asumes it's in C:
   MultiRequestChoice  from MRChoice.lha        script asumes it's in C:

   Version history:
   ---------------
   v1.0 initial release




   ==================================================
   = Change the next few lines to match your system =
   =  read the comments carefully!                 =
   ==================================================

*/



/* Change this to where you want to save the alarmlist, keep both "'" intact
   Warning! Script will have full controll of this file, it *will* delete old file */
tmpfile = 'S:tview_alarm.list'

/* Change path to where you placed the exe's. Keep both "'" intact */
setwinprg = 'C:SetWin'
mrchoiceprg = 'C:MultiRequestChoice'
txtreadprg = 'SYS:Utilities/MultiView'

/* If you want to see some debug output, change 0 -> 1 and run script from shell */
debug = 0



/* ========================== */
/* No more modifying required */
/* ========================== */

options results
call addlib('rexxtricks.library',0,-30,0)

arguments = '"Info" "Do you want to save the alarmlist?.\n\nRemember the items in the list should\nhave been freshly selected!\n\nDont use mouse&keyboard while\nscript is working!" "Yes|No"'
address command
mrchoiceprg arguments
startsvar = RC

IF startsvar = 1 THEN DO

     address command
     'resident c:wait'
     'delete >NIL: force '||tmpfile||''
     IF debug = 1 THEN DO
	SAY ''
	SAY 'Old alarmlist file deleted'
	SAY ''
	END

     address command
     SetWinprg||' "TView#?" ACTIVATE FRONT'
     wait 1

     address REXXEVENT
     "<control tab>"
     address command
     wait 1
     address REXXEVENT
     "<tab>"
     address command
     wait 1
     address REXXEVENT
     "<shift up>"
     address command
     wait 1
     address REXXEVENT
     "<control tab>"

     address command
     wait 1
     SetWinprg||' "Alarms" ACTIVATE FRONT'
     wait 1

     address REXXEVENT
     "<lcommand c>"

     address command
     wait 1

     IF debug = 1 THEN DO
	SAY '--- This is whats in clipboard ---'
	SAY READCLIPBOARD(0)
	SAY '----------------------------------'
	SAY ''
	CALL READCLIPBOARD(0,'cliplist')
	SAY 'Number of lines:' cliplist.0
	DO i = 1 TO cliplist.0
	   SAY 'Line' i || ':' cliplist.i
	   END
	SAY ''
	END

     CALL READCLIPBOARD(0,'cliplist')
     IF WRITEFILE(tmpfile,'cliplist') THEN DO
	IF debug = 1 THEN
	   SAY 'File written'
	IF SETCOMMENT(tmpfile,'1') THEN
	   IF debug = 1 THEN
	 SAY 'Filenote added'
	ELSE
	   IF debug = 1 THEN
	 SAY 'Error adding filenote!'
	END
     ELSE DO
	IF debug = 1 THEN
	   SAY 'Error saving file!'
	END

     IF debug = 1 THEN DO
	SAY ''
	SAY '--- This is whats in the saved file ---'
	address command
	'type '||tmpfile
	SAY '---------------------------------------'
	SAY ''
	END

     arguments = '"Info" "Alarmlist has been saved.\n\nDo you want to see whats in the saved file?" "Yes|No"'
     address command
     mrchoiceprg arguments
     svar = RC

     IF svar = 1 THEN
	txtreadprg tmpfile
     ELSE
	exit

END

ELSE
   exit

