/* Config-Netphone.rexx An easier way to set up speakfreely
$VER: Config-Netphone 7.6.101 (10-Jun-03)
 */

steps=8 /* How many licks does it take? */
options results
options failat 21

CR='0D'x /* Carriage Return: ASCII Character 13 */
LF='0A'x /* Linefeed: ASCII Character 10 */

         if ~ exists("libs:rexxreqtools.library") then
do
   say "Can't find rexxreqtools.library, aborting.."
   exit
end

if ~ show('L',"rexxreqtools.library") then
 do
   addlib('rexxreqtools.library',0,-30,0)
end
/* Get stuff from the environment */
    punit = 0
    runit = 0
    IF OPEN('pfile', 'ENV:SPEAKFREE_PLAY_UNIT', 'READ') THEN DO
        punit = READLN('pfile')
        CLOSE('pfile')
    END
    IF OPEN('rfile', 'ENV:SPEAKFREE_RECORD_UNIT', 'READ') THEN DO
        runit = READLN('rfile')
        CLOSE('rfile')
    END
IF punit<3 THEN punit = punit + 1
ELSE punit = 0
IF runit<3 THEN runit = runit + 1
ELSE runit = 0
ahiPlayUnit=rtezrequest("Choose an AHI unit for playing sound:", "0|1|2|3", "Step 1 of "steps,"rtez_defaultresponse ="punit )
ahiRecordUnit=rtezrequest("Choose an AHI unit for recording sound:", "0|1|2|3", "Step 2 of "steps,"rtez_defaultresponse ="runit)

        IF ahiPlayUnit > 0 THEN ahiPlayUnit = ahiPlayUnit -1
        ELSE IF ahiPlayUnit = 0 THEN ahiPlayUnit = 3
        IF ahiRecordUnit > 0 THEN ahiRecordUnit = ahiRecordUnit -1
        ELSE IF ahiRecordUnit = 0 THEN ahiRecordUnit = 3

CALL ChooseCompression /* its own function due to help text */

audioProtocol=rtezrequest("Choose your network protocol:", "SpeakFreely|VAT|Real Time Protocol", "Step 4 of "steps)
    IF audioProtocol=1 THEN audioProtocol=""
    IF audioProtocol=2 THEN audioProtocol="-vat"
    IF audioProtocol=0 THEN audioProtocol="-rtp"

sfDir = rtgetstring("", "Enter the drawer where speakfreely is installed:", "Choose drawer, Step 5 of "steps)

ringYN=rtezrequest("Do you want to send a ring before speaking?", "Yes|No", "Step 6 of "steps)
    IF ringYN=1 THEN DO
        ringFile = rtfilerequest(sfDir, "ring.au", "Choose audio (.au) file")
    END

CALL LWLTELL
CALL FACE

setYN = rtezrequest("We will now set your environment variables."LF"SPEAKFREE_PLAY_UNIT="ahiPlayUnit LF"SPEAKFREE_RECORD_UNIT="ahiRecordUnit LF"SPEAKFREE_LWL_TELL="lwlServer LF "SPEAKFREE_ID="lwlName ":" LF lwlEmail ":" LF lwlTelephone ":" LF lwlLocation LF'SPEAKFREE_FACE="'faceFile'"' LF'SPEAKFREE_FACE_VIEWER="'faceFileViewer'"', "Ok|Cancel")
    IF setYN = 1 THEN DO
        ADDRESS COMMAND 'setenv SAVE SPEAKFREE_PLAY_UNIT='ahiPlayUnit
        ADDRESS COMMAND 'setenv SAVE SPEAKFREE_RECORD_UNIT='ahiRecordUnit
        IF lwlYN=1 THEN ADDRESS COMMAND 'setenv SAVE SPEAKFREE_LWL_TELL='lwlServer
        ELSE DO
            ADDRESS COMMAND 'DELETE ENV:SPEAKFREE_LWL_TELL QUIET'
            ADDRESS COMMAND 'DELETE ENVARC:SPEAKFREE_LWL_TELL QUIET'
        END
        IF STRIP(faceFile) ~= "" THEN ADDRESS COMMAND 'setenv SAVE SPEAKFREE_FACE="'faceFile'"'
        ELSE DO
            ADDRESS COMMAND 'DELETE ENV:SPEAKFREE_FACE QUIET'
            ADDRESS COMMAND 'DELETE ENVARC:SPEAKFREE_FACE QUIET'
        END
    ADDRESS COMMAND 'setenv SPEAKFREE_FACE_VIEWER="'faceFileViewer'"'
    ADDRESS COMMAND 'setenv SAVE SPEAKFREE_ID="'lwlName':'lwlEmail':'lwlTelephone':'lwlLocation'"'
    END
setYN = rtezrequest("Now, we will amend the netphone.rexx script:"LF'sfdir="'sfDir'"' LF'sfring="'ringFile'"' LF'sfopts="'audioProtocol audioCompression'"', "Ok|Cancel")
i = 0
n = 0
IF setYN = 1 THEN DO
IF ~OPEN('scriptFile', sfDir'netphone.rexx', 'READ') THEN sfDir = sfDir"/" /* Maybe there's no trailing slash */
    IF OPEN('scriptFile', sfDir'netphone.rexx', 'READ') THEN DO
        DO WHILE ~EOF('scriptFile')
        Line.i = READLN('scriptFile')
        i = i + 1
        END
    CLOSE('scriptFile')
        IF OPEN('scriptFile', sfDir'netphone.rexx', 'WRITE') THEN DO n = 0 to i-1
          IF INDEX(Line.n, "sfdir=")>0 OR INDEX(Line.n, "sfring=")>0 OR INDEX(Line.n, "sfopts=")>0 THEN DO
            IF INDEX(Line.n, "sfdir=")>0 THEN WRITELN('scriptFile', 'sfdir="'sfDir'"')
            IF INDEX(Line.n, "sfring=")>0 THEN WRITELN('scriptFile', 'sfring="'ringFile'"')
            IF INDEX(Line.n, "sfopts=")>0 THEN WRITELN('scriptFile', 'sfopts="'audioProtocol audioCompression'"')
          END
        ELSE WRITELN('scriptFile', Line.n)
        END
    CLOSE('scriptFile')
    END
    ELSE rtezrequest("Couldn't open script file")
END
rtezrequest("Speakfreely and netphone are configured!")

EXIT

LWLTELL:
/* Get stuff from the environment */
        lwlName = ""
        lwlEmail = ""
        lwlTelephone = ""
        lwlLocation = ""
    IF OPEN('speakfreeId', 'ENV:SPEAKFREE_ID', 'READ') THEN DO
        stringID = READLN('speakfreeId')
        IF INDEX(stringID, ":")>0 THEN lwlName=STRIP(SUBSTR(stringId, 1, POS(":", stringId)-1))
              stringId = SUBSTR(stringId, POS(":", stringID)+1)
         IF INDEX(stringID, ":")>0 THEN lwlEmail=STRIP(SUBSTR(stringId, 1, POS(":", stringId)-1))
            stringId = SUBSTR(stringId, POS(":", stringID)+1)
         IF INDEX(stringID, ":")>0 THEN lwlTelephone=STRIP(SUBSTR(stringID, 1, POS(":", stringId)-1))
         IF INDEX(stringID, ":")>0 THEN lwlLocation = STRIP(SUBSTR(stringId, POS(":", stringID)+1))
    CLOSE('speakfreeId')
    END
    
    IF OPEN('speakfreeLwl', "ENV:SPEAKFREE_LWL_TELL", 'READ') THEN DO
        lwlServer = READLN('speakfreeLwl')
        CLOSE('speakfreeLwl')
    END
    ELSE lwlServer = "lwl.fourmilab.ch"

lwlYN = rtezrequest("Do you want to advertise your presence?", "Yes|No|Huh?", "Step 7 of "steps)
    IF lwlYN = 0 THEN DO
        rtezrequest("If you choose yes, you will be asked"LF"for the name of a Look Who's Listening server."LF"Your IP address, email, and other details"LF"will be advertised for the whole world to see!", ,"Explanation")
    Call LWLTELL
    END
        
      IF lwlYN=1 THEN DO
 
        lwlServer = rtgetstring(lwlServer, "Enter server name or IP", "Choose Server")
            lwlName = rtgetstring(lwlName,"Enter your name", "Your details")
            lwlEmail = rtgetstring(lwlEmail, "Enter your email address", "Your details")
            lwlTelephone = rtgetstring(lwlTelephone, "Enter your telephone number", "Your details")
            lwlLocation = rtgetstring(lwlLocation, "Enter your location", "Your Details")  
        END

    IF lwlYN=2 then DO
            lwlServer=""
            lwlName = ""
            lwlEmail = ""
            lwlTelephone = ""
            lwlLocation = ""
    END

RETURN 0

ChooseCompression:
audioCompression = rtezrequest("Choose an audio format", "NONE|ADPCM|GSM|LPC|LPC10|CELP|Huh?", "Step 3 of "steps)

    IF audioCompression = 0 THEN DO 
    rtezrequest("The compression methods are a trade-off"LF" between bandwidth and processing power. "LF"From left to right, the methods get more CPU intense,"LF" but use less bandwidth.",,"Explanation")
    CALL ChooseCompression
    END
ELSE DO 
    IF audioCompression = 1 THEN audioCompression = "-c"
    IF audioCompression = 2 THEN audioCompression = "-f"
    IF audioCompression = 3 THEN audioCompression = "-t"
    IF audioCompression = 4 THEN audioCompression = "-lpc"
    IF audioCompression = 5 THEN audioCompression = "-lpc10"
    IF audioCompression = 6 THEN audioCompression = "-CELP"
END
return 0

FACE:
faceYN = rtezrequest("Do you want to show your face?", "Yes|No|Huh?", "Step 8 of "steps)
    IF faceYN = 0 THEN DO
        rtezrequest("You can specify an image to send to the"LF"calling or called party."LF"This image should be a Windows BMP file, but"LF"can be any kind of image to another Amiga user.")
    CALL FACE
    END

    IF faceYN = 1 THEN DO
        faceFile=rtfilerequest(sfDir, ,"Choose a face file")
    END
        faceFileViewer = rtfilerequest("SYS:Utilities","Multiview","Choose a face file viewer")

return 0
/* Okay... */
